#include <mega32.h>
#include <delay.h>


 unsigned  char RGBStat[512]={

0,0,0,0    ,0,0,0,0    ,0,0,0,0     ,0,0,0,0    ,0,0,0,0    ,0,0,0,0       ,0,0,0,0     ,0,0,0,
0,0,0,0    ,0,0,0,0    ,0,0,0,0     ,0,0,0,0    ,0,0,0,0    ,0,0,0,0       ,0,0,0,0     ,0,0,0,
0,0,0,0    ,0,0,0,0    ,0,0,0,0     ,0,0,0,0    ,0,0,0,0    ,0,0,0,0       ,0,0,0,0     ,0,0,0,
0,0,0,0    ,0,0,0,0    ,0,0,0,0     ,0,0,0,0    ,0,0,0,0    ,0,0,0,0       ,0,0,0,0     ,0,0,0,

0,0,0,0    ,0,0,0,0    ,0,0,0,0     ,0,0,0,0    ,0,0,0,0    ,0,0,0,0       ,0,0,0,0     ,0,0,0,
0,0,0,0    ,0,0,0,0    ,0,0,0,0     ,0,0,0,0    ,0,0,0,0    ,0,0,0,0       ,0,0,0,0     ,0,0,0,
0,0,0,0    ,0,0,0,0    ,0,0,0,0     ,0,0,0,0    ,0,0,0,0    ,0,0,0,0       ,0,0,0,0     ,0,0,0,
0,0,0,0    ,0,0,0,0    ,0,0,0,0     ,0,0,0,0    ,0,0,0,0    ,0,0,0,0       ,0,0,0,0     ,0,0,0,

0,0,0,0    ,0,0,0,0    ,0,0,0,0     ,0,0,0,0    ,0,0,0,0    ,0,0,0,0       ,0,0,0,0     ,0,0,0,
0,0,0,0    ,0,0,0,0    ,0,0,0,0     ,0,0,0,0    ,0,0,0,0    ,0,0,0,0       ,0,0,0,0     ,0,0,0,
0,0,0,0    ,0,0,0,0    ,0,0,0,0     ,0,0,0,0    ,0,0,0,0    ,0,0,0,0       ,0,0,0,0     ,0,0,0,
0,0,0,0    ,0,0,0,0    ,0,0,0,0     ,0,0,0,0    ,0,0,0,0    ,0,0,0,0       ,0,0,0,0     ,0,0,0,

0,0,0,0    ,0,0,0,0    ,0,0,0,0     ,0,0,0,0    ,0,0,0,0    ,0,0,0,0       ,0,0,0,0     ,0,0,0,
0,0,0,0    ,0,0,0,0    ,0,0,0,0     ,0,0,0,0    ,0,0,0,0    ,0,0,0,0       ,0,0,0,0     ,0,0,0,
0,0,0,0    ,0,0,0,0    ,0,0,0,0     ,0,0,0,0    ,0,0,0,0    ,0,0,0,0       ,0,0,0,0     ,0,0,0,
0,0,0,0    ,0,0,0,0    ,0,0,0,0     ,0,0,0,0    ,0,0,0,0    ,0,0,0,0       ,0,0,0,0     ,0,0,0,

                                                                                                                                                  
 };

int i;;



#ifndef RXB8
#define RXB8 1
#endif

#ifndef TXB8
#define TXB8 0
#endif

#ifndef UPE
#define UPE 2
#endif

#ifndef DOR
#define DOR 3
#endif

#ifndef FE
#define FE 4
#endif

#ifndef UDRE
#define UDRE 5
#endif

#ifndef RXC
#define RXC 7
#endif

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<DOR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// Write a character to the USART Transmitter
#ifndef _DEBUG_TERMINAL_IO_
#define _ALTERNATE_PUTCHAR_
#pragma used+
void putchar(char c)
{
while ((UCSRA & DATA_REGISTER_EMPTY)==0);
UDR=c;
}
#pragma used-
#endif

//****************************************************************************************************************
void UartEnable(void)
{
PORTD.1 = 1;
DDRD.1 = 0; //PORTD.1 as Input
UCSRB=0x08;
}
//****************************************************************************************************************
void UartDisable(void)
{
PORTD.1 = 1;
DDRD.1 = 1; //PORTD.1 as output
UCSRB=0x00;
}
//****************************************************************************************************************
void Wait( unsigned long int delay )
{
unsigned long int jj;
for( jj=0; jj<delay; jj++ ){};
}

void main(void)
{

unsigned  char channel=0;
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
PORTA=0xFF;
DDRA=0x00;

 // Port D initialization
// Func7=Out Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=0 State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x80;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 62.500 kHz
// Mode: Fast PWM top=0xFF
// OC2 output: Inverted PWM
ASSR=0x00;
TCCR2=0x7E;
TCNT2=0x00;
OCR2=0x00;


// USART initialization
// Communication Parameters: 8 Data, 2 Stop, No Parity
// USART Receiver: Off
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 250000
UCSRA=0x00;
UCSRB=0x08;
UCSRC=0x8E;
UBRRH=0x00;
UBRRL=0x03;

delay_ms(1000);

while (1)
      {

            UartDisable();
            PORTD.1 = 0;    
            Wait(50); 
            UartEnable();
            putchar( 0 ); 
                       
            channel=PINA;
            
            OCR2=RGBStat[channel];
             
                for ( i=0; i< 512; i++)
                {        
                    
                  putchar(RGBStat[i]); 

                };  


      }
}
